/*


Java Listing 2. An Integer List Abstract Data Type
This listing is a Java class that represents a dynamic list of integers. Elements can be added to, and removed from, the list at any point. The list is represented as a collection of integer node objects.



*/

class IntList implements java.io.Serializable
{
  int numNodes;
  IntNode head;

  public IntList ()
  {
    head = null;
    numNodes = 0;
  }

  public void insertAtHead (int item)
  {
    IntNode aNode = new IntNode (item, head);
 
    numNodes++;
    head = aNode;
  }

  public boolean insertAfter (int target,
                              int newValue)
  {
    if (numNodes == 0)
      return false;

    IntNode aNode = head;
    while (aNode != null)
    {
      if (aNode.getData () == target)
      {
        IntNode inNode = new IntNode (newValue,
                                aNode.getLink ());
        aNode.setLink (inNode);
        numNodes++;
        return true;
      }

      aNode = aNode.getLink ();
    }

    return false;
  }

  public boolean deleteElement (int target)
  {
    if (numNodes == 0)
      return false;

    IntNode currNode = head;
    IntNode nextNode = head.getLink ();

    if (nextNode == null)
      head = null;

    while (nextNode != null)
    {
      if (nextNode.getData () == target)
      {
        currNode.setLink (nextNode.getLink ());
        numNodes--;
        return true;
      }

      currNode = currNode.getLink ();
      nextNode = nextNode.getLink ();
    }

    return false;
  }

  public boolean removeFromHead ()
  {
    if (numNodes == 0)
      return false;

    head = head.getLink ();
    numNodes--;
    return true;
  }

  public void showList ()
  {
    System.out.println ("Number of nodes: " +
                                numNodes);
    IntNode aNode = head;

    while (aNode != null)
    {
      System.out.print (aNode.getData () + "  ");
      aNode = aNode.getLink ();
    }

    System.out.println ();
  }
}
