/*

Listing 3. Integer List Test Class
This program listing is a Java class, IntListOps, which performs various operations on the integer list abstract data type. This includes serialization to write an entire list object to disk, which is then used to create a new instance of a list object. By following the program code, you can see how simple the serialization is. By running the program, you will see how effortlessly it works, with the new instance of the list object holding identical contents to the list object that was serialized to disk.

*/

import java.io.*;

public class IntListOps
{
  public static void main (String[] args)
  {
    System.out.println
         ("-->Testing linked list classes\n");

    IntList list1 = new IntList ();

    list1.insertAtHead (20);
    list1.insertAtHead (30);
    list1.insertAtHead (40);
    list1.insertAtHead (50);

    list1.showList ();

    System.out.println ("--> Saving list1 to disk");

    try
    {
      FileOutputStream f_out = new
             FileOutputStream ("list.data");
      ObjectOutputStream obj_out = new
             ObjectOutputStream (f_out);
      obj_out.writeObject (list1);
    }
    catch (Exception e)
    {
      System.out.println (e.toString ());
      System.exit (1);
    }

    System.out.println ("--> Doing more to list1");

    list1.removeFromHead ();
    list1.showList ();

    System.out.println
              ("--> Creating new, empty list2");

    IntList list2 = new IntList ();
    list2.showList ();

    System.out.println
              ("--> Loading saved data into list2");
    Object obj = new Object ();

    try
    {
      FileInputStream f_in = new
              FileInputStream ("list.data");
      ObjectInputStream obj_in = new
              ObjectInputStream (f_in);
      obj = obj_in.readObject ();
    }
    catch (Exception e)
    {
      System.out.println (e.toString ());
      System.exit (1);
    }

    if (!(obj instanceof IntList))
    {
      System.out.println
          ("Hmm, list.data does not hold a list!");
      System.exit (1);
    }

    list2 = (IntList) obj;
    list2.showList ();
  }
}
